//
#define trim_0up   PINA.3
#define trim_0down PINA.0
#define trim_1up   PINA.1
#define trim_1down PINA.2
#define trim_2up   PINA.5
#define trim_2down PINA.4
#define trim_3up   PINA.7
#define trim_3down PINA.6     

//   
#define UP    PIND.4
#define DOWN  PIND.5          
#define LEFT  PIND.6
#define RIGHT PIND.7

//

#define BUZ   PORTG.2
//
#define LED1 PORTC.6
#define LED2 PORTC.7

//
#define MODE_KEY1       PINE.6
#define MODE_KEY2       PINE.7    
#define SW1             PINE.4  
#define SW2_1           PINE.3
#define SW2_2           PINE.2
#define SW3             PINE.5

#define Tcut_KEY        PINC.3     
#define DUAL_ail        PINC.1     
#define DUAL_elev       PINC.0  
#define DUAL_rud        PINC.2     

//  
#define Ailerons        5
#define Elevator        4
#define Throttle        6
#define Rudder          3
#define Rpop_contr      2
#define Batt            7

        


// Model types
#define TYPE_HELI		0
#define TYPE_PLANE		1
#define TYPE_GLIDER		2

// Fly modes
#define	M_NORMAL		0
#define	M_IDLEUP1		1
#define	M_IDLEUP2		2
#define	M_THOLD			3
#define	MAX_MODES		4

//Channels
#define CHAN_AIL		0
#define CHAN_ELE		1
#define CHAN_THR		2
#define CHAN_RUD		3
#define CHAN_GYRO		4
#define CHAN_PITCH		5
#define CHAN_GOV		6
#define CHAN_AUX1		7
#define CHAN_AUX2		8
#define MAX_CHANS		9
#define MAX_CONTR		10
#define CHAN_MIN                9
#define CHAN_MID		10
#define CHAN_MAX		11
#define CHAN_SW_L		12
#define CHAN_SW_R		13
#define CHAN_NONE		14

// TX Modulation types
#define MODUL_PPM               0
#define MODUL_IPPM              1
#define MODUL_PCM               2
#define MAX_MODULS		3

#define CURVE_NODES		7
#define MAX_MODELS              4

// 
#define reset PORTC.4
#define DC PORTC.5



