

 #define MAXST 5;

typedef unsigned char byte;
 

 __flash const char  *modeNames[2][3] = 
   {
        {
	"Landing ",
	"Normal  ",
	"Pilotage"
	
        },
    
        {
	"Normal  ",
	"IddleUp ",
	"T Hold  "
	
        }
    }; 


__flash const char  *modulNames[] = {
	"PPM ",
	"IPPM",
        "PCM"
};


__flash const char  *menuT0[] = {
	"Model    >",
	"Controls >",
	"Channels >",
	"Timer    >",
	"Options  >"
};
__flash const char  menuT0L = 5;

__flash const char  *menuT1[] ={
	"Select   >",
	"Reset     ",
	"Copy     >",
	"Name     >",
	"Type     >",
	"Mods Copy>",
	"Modu Type>",
        "MAX CH   >"
};

__flash const char  menuT1L =8; 


__flash const char  *menuT2[] = {
	"Ailerons >",
	"Elevator >",
	"Throttle >",
	"Rudder   >",
	"SW 1     >",
	"SW 2     >",
	"SW 3     >",
	"Prop     >",
	"User's 1 >",
	"User's 2 >",
        "Trim      >"

};
__flash const char  menuT2L =10; 


__flash const char  *menuT3[] = {
	"Set     ",
	"Mode    ",
	"Control "
};
__flash const char  menuT3L =2; 

__flash const char  *menuT4[] = {
	"Sound    >",
	"Bcklight >",
	"Contrast >",
	"Sleep    >"
};
__flash const char  menuT4L =1;


__flash const char  *menuT5[] = {
	"CH 1     >",
	"CH 2     >",
	"CH 3     >",
	"CH 4     >",
	"CH 5     >",
	"CH 6     >",
	"CH 7     >",
	"CH 8     >"	
};

__flash const char  menuT5L =8; 

__flash const char  *menuT6[] = {
	"Plane",
	"Heli "
	
};





__flash const char  NM[] ={37,42,20,22,36,0,0,0};




__flash const char  *Timer_modes1[] = {
	"UP  ",
	"DOWN"
	
};

__flash const char  *Timer_modes2[] = {
	"Sound ON ",
	"Sound OFF"
	
};

__flash const char  Name_table[65] = {
' ','_','-','0','1','2','3','4','5','6','7','8','9','A','a','B','b','C','c','D',
'd','E','e','F','f','G','g','H','h','I','i','J','j','K','k','L','l','M','m','N',	
'n','O','o','P','p','Q','q','R','r','S','s','T','t','U','u','V','v','W','w','X',
'x','Y','y','Z','z'};


void name_init(void)
{
  screen_name[8]='\0';
      
   for (i=0; i<8; i++)  screen_name[i]=Name_table[curmodel.name[i]];

}

void trim_sound (void)
{
if (trim_sound_en&&sound)
        {
        trim_sound_en=0;
        PORTG|=0x4;
        delay_ms(30);
        PORTG&=0xFB;
        delay_ms(30);
        }
}
        
        
void BEEP (void)
{   
if (sound)
        {
        PORTG|=0x4;
        delay_ms(50);
        PORTG&=0xFB;
        delay_ms(50);
        }
else delay_ms(100);
}
void BEEP1 (void)
{   
if (sound)
        {
        PORTG|=0x4;
        delay_ms(20);
        PORTG&=0xFB;
        delay_ms(20);
        }
else delay_ms(40);
}
  

void MODEL_reset (void)
{char MOD, con,i;

#asm("cli")
 for (con=0; con<10; con++)
        for (MOD=0; MOD<4; MOD++)
                { 
 
                reverse[cur_model_num][con][MOD]=1;
      
                maxRates[cur_model_num][con][MOD]=100;
                minRates[cur_model_num][con][MOD]=100;						// EPA val in 2% unit
        
                maxDRates[cur_model_num][con][MOD]=100;					// EPA val in 2% unit
                minDRates[cur_model_num][con][MOD]=100;
                

//	eeprom char		        exponent[MAX_MODELS][MAX_CONTR][MAX_MODES];					// T-Cut for throttle channel
	        
	        nodes[cur_model_num][con][0][MOD]=-100;
                nodes[cur_model_num][con][1][MOD]=-66;
                nodes[cur_model_num][con][2][MOD]=-34;
                nodes[cur_model_num][con][3][MOD]=0;
                nodes[cur_model_num][con][4][MOD]=34;
                nodes[cur_model_num][con][5][MOD]=66;
                nodes[cur_model_num][con][6][MOD]=100;

                
                
                
                
                
                }	
for (con=0; con<8; con++)
        for (MOD=0; MOD<4; MOD++)
                for (i=0; i<11; i++)                
                        CH[cur_model_num][con][i][MOD]=0;
for (MOD=0; MOD<4; MOD++)
        {				
        for (i=0; i<8; i++)
                CH[cur_model_num][i][i][MOD]=100;	
 
 num_ch[cur_model_num]=6;  		
	}
	
	
	
for (i=0; i<8; i++)name[cur_model_num][i]=NM[i];
	
modulation[cur_model_num]=0;

for (i=0; i<4; i++)
        for (MOD=0; MOD<4; MOD++)     trimmer[cur_model_num][MOD][i]=0;


	type[cur_model_num]=0;				// heli, plane, etc.

timer[cur_model_num]=0;
 timer_mode[cur_model_num]=0;
 
 #asm("sei")
}

void MODEL_init (void)
{char MOD, con,node_num,i;
  BEEP();

#asm("cli")
 for (con=0; con<10; con++)
        for (MOD=0; MOD<4; MOD++)
                {   
 
                contr[con].reverse[MOD]=reverse[cur_model_num][con][MOD];
      
                contr[con].maxRates[MOD]=maxRates[cur_model_num][con][MOD];
                contr[con].minRates[MOD]=minRates[cur_model_num][con][MOD];						// EPA val in 2% unit
        
                contr[con].maxDRates[MOD]=maxDRates[cur_model_num][con][MOD];					// EPA val in 2% unit
                contr[con].minDRates[MOD]=minDRates[cur_model_num][con][MOD];
                contr[con].from[MOD]=from[cur_model_num][con][MOD];


	        
	        for (node_num=0; node_num<7; node_num++)
                contr[con].nodes[node_num][MOD]=nodes[cur_model_num][con][node_num][MOD];
                }	
        
        

for (con=0; con<8; con++)
        for (MOD=0; MOD<4; MOD++)
                for (i=0; i<11; i++)                
                        chans[con].CH[i][MOD]=CH[cur_model_num][con][i][MOD];
	
	
  for (i=0; i<8; i++)curmodel.name[i]=name[cur_model_num][i];	

	curmodel.type=type[cur_model_num];				// heli, plane, etc.


for (i=0; i<4; i++)
        for (MOD=0; MOD<4; MOD++)     curmodel.trimmer[MOD][i]=trimmer[cur_model_num][MOD][i];

curmodel.modulation= modulation[cur_model_num];


curmodel.timer=timer[cur_model_num];
curmodel.timer_mode=timer_mode[cur_model_num];

curmodel.num_ch=num_ch[cur_model_num];   

 name_init();
 #asm("sei")
 }
 
 void MODEL_copy (char f, char to)
        {char MOD, con,node_num,i;
  BEEP();
 
#asm("cli")
 for (con=0; con<10; con++)
        for (MOD=0; MOD<4; MOD++)
                {   
 
                reverse[to][con][MOD]=reverse[f][con][MOD];
      
                maxRates[to][con][MOD]=maxRates[f][con][MOD];
                minRates[to][con][MOD]=minRates[f][con][MOD];						// EPA val in 2% unit
        
                maxDRates[to][con][MOD]=maxDRates[f][con][MOD];					// EPA val in 2% unit
                minDRates[to][con][MOD]=minDRates[f][con][MOD];
                from[to][con][MOD]=from[f][con][MOD];

//	eeprom char		        exponent[MAX_MODELS][MAX_CONTR][MAX_MODES];					// T-Cut for throttle channel
	        
	        for (node_num=0; node_num<7; node_num++)
                nodes[to][con][node_num][MOD]=nodes[f][con][node_num][MOD];
                }	
                
                
for (con=0; con<8; con++)
        for (MOD=0; MOD<4; MOD++)
                for (i=0; i<11; i++)                
                        CH[to][con][i][MOD]=CH[f][con][i][MOD];
	
	
        for (i=0; i<8; i++)name[to][i]=name[f][i];	

	
	
	type[to]=type[f];				// heli, plane, etc.

for (i=0; i<4; i++)
        for (MOD=0; MOD<4; MOD++)     trimmer[to][MOD][i]=trimmer[f][MOD][i];


modulation[to]=modulation[f];


timer[to]=timer[f];
timer_mode[to]=timer_mode[f];

num_ch[to]=num_ch[f];  
        
        #asm("sei")
 }
 
void MODE_copy (char f, char to)
        {char MOD, con,node_num,i;
  BEEP();

#asm("cli")
 for (con=0; con<10; con++)
       
                {   
 
                reverse[cur_model_num][con][to]=reverse[cur_model_num][con][f];
      
                maxRates[cur_model_num][con][to]=maxRates[cur_model_num][con][f];
                minRates[cur_model_num][con][to]=minRates[cur_model_num][con][f];						// EPA val in 2% unit
        
                maxDRates[cur_model_num][con][to]=maxDRates[cur_model_num][con][f];					// EPA val in 2% unit
                minDRates[cur_model_num][con][to]=minDRates[cur_model_num][con][f];
                
                from[cur_model_num][con][to]=from[cur_model_num][con][f];

				
	        
	        for (node_num=0; node_num<7; node_num++)
                nodes[cur_model_num][con][node_num][to]=nodes[cur_model_num][con][node_num][f];
                }
                
                
                	
for (con=0; con<8; con++)
                for (i=0; i<11; i++)                
                        CH[cur_model_num][con][i][to]=CH[cur_model_num][con][i][f];
	
   for (i=0; i<4; i++)
        for (MOD=0; MOD<4; MOD++)     trimmer[cur_model_num][to][i]=trimmer[cur_model_num][f][i];	
        
        
        } 
 
 
int scroll (byte p,byte L)
 { if (!UP&&p<L-1)
                { p++;
                  BEEP();              }
        if (!DOWN&&p>0)
                {     
                p--;
                          
                 BEEP();         }
  return (p);
  #asm("sei")
  }
 
       
  void SAVE_CH (char NMOD,char N,char sel)
   {
        BEEP();
   
        
        if (sel==0) reverse[NMOD][N][FLY_MODE]=  contr[N].reverse[FLY_MODE] ;
        if (sel==2) minRates[NMOD][N][FLY_MODE]=  contr[N].minRates[FLY_MODE] ;
        if (sel==3) maxRates[NMOD][N][FLY_MODE]=  contr[N].maxRates[FLY_MODE] ;
        if (N<4)
                {
                if (sel==4) minDRates[NMOD][N][FLY_MODE]=  contr[N].minDRates[FLY_MODE] ;
                if (sel==5) maxDRates[NMOD][N][FLY_MODE]=  contr[N].maxDRates[FLY_MODE] ;
                }
        if (N>7&&sel==4) from[NMOD][N][FLY_MODE]=  contr[N].from[FLY_MODE] ;
  
       BEEP();
  
   }   
   
void edit_curve (char sel)
{ char Y[7];

lcd_line(5,16,89,16,1);
lcd_line(5,56,5,16,1);
lcd_line(89,56,89,16,1);
lcd_line(5,56,89,56,1);
lcd_dashline(5,36,89,36);
lcd_dashline(47,16,47,56);  
lcd_dashline(19,16,19,56);   
lcd_dashline(33,16,33,56);  
lcd_dashline(61,16,61,56);
lcd_dashline(75,16,75,56) ;
  
        Y[0]=contr[pos[1]].nodes[0][FLY_MODE]/-5+36;
        Y[1]=contr[pos[1]].nodes[1][FLY_MODE]/-5+36;
        Y[2]=contr[pos[1]].nodes[2][FLY_MODE]/-5+36;
        Y[3]=contr[pos[1]].nodes[3][FLY_MODE]/-5+36;
        Y[4]=contr[pos[1]].nodes[4][FLY_MODE]/-5+36;
        Y[5]=contr[pos[1]].nodes[5][FLY_MODE]/-5+36;
        Y[6]=contr[pos[1]].nodes[6][FLY_MODE]/-5+36;


lcd_line(5,Y[0],19,Y[1],1);
lcd_line(19,Y[1],33,Y[2],1);
lcd_line(33,Y[2],47,Y[3],1);
lcd_line(47,Y[3],61,Y[4],1);
lcd_line(61,Y[4],75,Y[5],1);
lcd_line(75,Y[5],89,Y[6],1);

lcd_rectangle(3+sel*14,Y[sel]+2,7+sel*14,Y[sel]-2,1);


sprintf(buf,"%-i",contr[pos[1]].nodes[sel][FLY_MODE]);
lcd_setxy(2,57);
if (!edit_cur)lcd_wrs(buf,255);
else  lcd_wrs(buf,Clip);
}   
      

void SAVE_NODE (void)
{ BEEP();
 nodes[cur_model_num][pos[1]][pos[3]][FLY_MODE]=contr[pos[1]].nodes[pos[3]][FLY_MODE];      
BEEP();
}









   void menu_item (__flash const char  **name, byte leng, byte sel)
        {   byte i, f,l,c;
        if (leng>5) {
                lcd_line(92,18,92,64,1);
                lcd_line(95,18,95,64,1);
        
                if (sel>=5)
                        {
                        lcd_line(93,41,93,64,1);
                        lcd_line(94,41,94,64,1);
                        lcd_line(93,18,94,18,1);
                        f=5; 
                        l=leng;
                        }      
        
                else
                        {
                        lcd_line(93,18,93,41,1);
                        lcd_line(94,18,94,41,1);
                        lcd_line(93,64,94,64,1);
                        f=0; 
                        l=5;
                        }      
        
                      }
        else
        {f=0;
         l=leng;
         }
        
        
        c=0;
        for (i=f; i<l; i++)
                {
                            lcd_setxy(10,c*9+18);
                            lcd_wrsf(name[i],255);
                            if (i==sel)
                                {
                                
                                lcd_setxy(10,c*9+18);
                                lcd_wrsf(name[i],0);
                                }
                               c++;
                }
        
        }  
     
     
void edit_CH (char N,char sel)
{
 if (sel==0)
        {
        lcd_setxy(0,20);
        if (edit==0) lcd_wrsf("Rev  ",0);   
        else lcd_wrsf("Rev  ",Clip);
        if (contr[N].reverse[FLY_MODE]==-1)
                {
              lcd_setxy(31,20);
                lcd_char(124,0);
                }
        else
                {
              lcd_setxy(31,20);
                
                lcd_char(123,0);
                }
        }
 else   {
        lcd_setxy(0,20);
        lcd_wrsf("Rev  ",255);                      
        if (contr[N].reverse[FLY_MODE]==-1)
                {
              lcd_setxy(31,20);
                lcd_char(124,255);
                }
        else
                {
              lcd_setxy(31,20);
                lcd_char(123,255);
                }
        
        
        }
if (N<4||N>6) 
        {       
        if (sel==1)
                {
                lcd_setxy(46,20);
                lcd_wrsf("Curve>",0);         
                }       
        else
                {
                lcd_setxy(46,20);
                lcd_wrsf("Curve>",255);         
                }
        }
        
 lcd_setxy(8,30);
        lcd_wrsf("Rate ",255);  
sprintf(buf,"%-i",contr[N].minRates[FLY_MODE]);
if (sel==2)
        {
        lcd_setxy(44,30);
        if (!edit)lcd_wrs(buf,0);
        else  lcd_wrs(buf,Clip);        
        }
else
        {
        lcd_setxy(44,30);
        lcd_wrs(buf,255);         
        }
sprintf(buf,"%-i",contr[N].maxRates[FLY_MODE]);        
 if (sel==3)
        {
        lcd_setxy(72,30);
         if (!edit)lcd_wrs(buf,0);
        else  lcd_wrs(buf,Clip);         
        }
else
        {
        lcd_setxy(72,30);
        lcd_wrs(buf,255);         
        }




  
if (N<4&&N!=2)
        {
         lcd_setxy(0,40);
         lcd_wrsf("DRate ",255); 
        sprintf(buf,"%-i",contr[N].minDRates[FLY_MODE]);   
        if (sel==4)
                {
                lcd_setxy(44,40);
                if (!edit)lcd_wrs(buf,0);
                else  lcd_wrs(buf,Clip);   
                         
                }
        else
                {
                lcd_setxy(44,40);
                lcd_wrs(buf,255);      
                }             
       sprintf(buf,"%-i",contr[N].maxDRates[FLY_MODE]);   
        if (sel==5)
                {
                lcd_setxy(72,40);
                if (!edit)lcd_wrs(buf,0);
                else  lcd_wrs(buf,Clip);   
                         
                }
        else
                {
                lcd_setxy(72,40);
                lcd_wrs(buf,255);      
                }             
       
       
       
       
        }
   
if (N==2)
        {
         lcd_setxy(2,40);
                lcd_wrsf("Tcut ",255);
       sprintf(buf,"%-i",contr[N].minDRates[FLY_MODE]);
        if (sel==4)
                {
                lcd_setxy(44,40);
              if (!edit) lcd_wrs(buf,0);
                else  lcd_wrs(buf,Clip);
                       
                }
        else
                {
                 lcd_setxy(44,40);
                lcd_wrs(buf,255);        
                }             
        } 
 if (N>7)
        {lcd_setxy(2,42);
                lcd_wrsf("From: ",255);    
        if (sel==4)
                {
        
                lcd_setxy(8,50);
                if (!edit)lcd_wrsf(menuT2[contr[pos[1]].from[FLY_MODE]] ,0);
                else  lcd_wrsf(menuT2[contr[pos[1]].from[FLY_MODE]] ,Clip);        
                }
        else
                {
                lcd_setxy(8,50);
                lcd_wrsf(menuT2[contr[pos[1]].from[FLY_MODE]] ,255);      
                }             
        } 
 
 }

void wr_trimmer (void)
{  char tr[4];


tr[2]=curmodel.trimmer[FLY_MODE][2]/-5+40;

lcd_line(6,24,6,56,1); 

lcd_pixel(7,24,1);
lcd_pixel(8,24,1);
lcd_pixel(7,28,1);
lcd_pixel(7,32,1);
lcd_pixel(7,36,1);
lcd_pixel(7,40,1);
lcd_pixel(8,40,1);
lcd_pixel(7,44,1);
lcd_pixel(7,48,1);
lcd_pixel(7,52,1);
lcd_pixel(7,56,1);
lcd_pixel(8,56,1);

lcd_pixel(9,tr[2],1); 
lcd_line(10,tr[2]-1,10,tr[2]+1,1);
lcd_line(11,tr[2]-2,11,tr[2]+2,1);


tr[1]=curmodel.trimmer[FLY_MODE][1]/-5+40; 
lcd_line(89,24,89,56,1); 

lcd_pixel(88,24,1);
lcd_pixel(87,24,1);
lcd_pixel(88,28,1);
lcd_pixel(88,32,1);
lcd_pixel(88,36,1);
lcd_pixel(88,40,1);
lcd_pixel(87,40,1);
lcd_pixel(88,44,1);
lcd_pixel(88,48,1);
lcd_pixel(88,52,1);
lcd_pixel(88,56,1);
lcd_pixel(87,56,1);

lcd_pixel(86,tr[1],1); 
lcd_line(85,tr[1]-1,85,tr[1]+1,1);
lcd_line(84,tr[1]-2,84,tr[1]+2,1); 


tr[3]=curmodel.trimmer[FLY_MODE][3]/5+26; 
lcd_line(10,63,42,63,1);
lcd_pixel(10,61,1);
lcd_pixel(10,62,1);
lcd_pixel(14,62,1);
lcd_pixel(18,62,1);
lcd_pixel(22,62,1);
lcd_pixel(26,62,1);
lcd_pixel(26,61,1);
lcd_pixel(30,62,1);
lcd_pixel(34,62,1);
lcd_pixel(38,62,1);
lcd_pixel(42,62,1);
lcd_pixel(42,61,1); 

lcd_pixel(tr[3],60,1); 
lcd_line(tr[3]-1,59,tr[3]+1,59,1);
lcd_line(tr[3]-2,58,tr[3]+2,58,1);


tr[0]=curmodel.trimmer[FLY_MODE][0]/5+68; 
lcd_line(52,63,84,63,1);
lcd_pixel(52,62,1);
lcd_pixel(52,61,1);
lcd_pixel(56,62,1);
lcd_pixel(60,62,1);
lcd_pixel(64,62,1);
lcd_pixel(68,62,1);
lcd_pixel(68,61,1);
lcd_pixel(72,62,1);
lcd_pixel(76,62,1);
lcd_pixel(80,62,1);
lcd_pixel(84,62,1);
lcd_pixel(84,61,1); 

lcd_pixel(tr[0],60,1); 
lcd_line(tr[0]-1,59,tr[0]+1,59,1);
lcd_line(tr[0]-2,58,tr[0]+2,58,1); 


}


void main_scr (void)
        {char min[2],sec[2];
        
        
        lcd_setxy(0,0);
        sprintf(buf,"0%-i",cur_model_num+1);
        lcd_wrs(buf,255);
        lcd_setxy(16,0);
        if (curmodel.type==1)            // 
                {
                lcd_char(125,255); 
                lcd_char(126,255); 
                }                                                                ///***************************
        if (curmodel.type==0)            // 
                {
                lcd_char(127,255); 
                lcd_char(128,255); 
                }  
   
   
   
   if (Cut_enable)
        {
        lcd_setxy(65,15);
        lcd_char(129,255);
        lcd_char(130,255);
        lcd_setxy(65,23);
        lcd_char(131,255);
        lcd_char(132,255);
        }
   
   
   lcd_setxy(25,20); 
     sprintf(buf,"%-i.%-iV",U_bat/100,U_bat/10%10);
      lcd_wrs(buf,255);
      
   
      lcd_setxy(33,0);
      lcd_wrs(screen_name,255);
                        
       
    
    lcd_setxy(0,9);  
    lcd_wrsf(modeNames[curmodel.type][FLY_MODE],255);  
     
     //lcd_fillrect(24,18,68,30,1);
     //lcd_fillrect(68,22,71,26,1);
     
    min[0]=time/600;
    min[1]=time/60%10;
    sec[0]=time%60/10;
    sec[1]=time%10;
    
    lcd_setxy(42,35);
    lcd_deg12x16(10,255);
    
    lcd_setxy(19,36);
    lcd_deg12x16(min[0],255);
    lcd_setxy(32,36);
    lcd_deg12x16(min[1],255);
    
     
    lcd_setxy(50,36);
    lcd_deg12x16(sec[0],255);
    lcd_setxy(63,36);
    lcd_deg12x16(sec[1],255);
   
    
    wr_trimmer();
    
        }
      
    /*  
      void main_scr (void)
        {
      lcd_setxy(1,10);
      sprintf(buf,"%-i  %-i",output[0], out_cur[4]);
      lcd_wrs(buf,255); 
       
     
     lcd_setxy(1,20);
     
      
     sprintf(buf,"%-i  %-i",output[1], out_cur[5]);
      lcd_wrs(buf,255);
       
 
     lcd_setxy(1,30);
     
     sprintf(buf,"%-i  %-i",output[2], out_cur[6]);
      lcd_wrs(buf,255);
     
     lcd_setxy(1,40);
     
     sprintf(buf,"%-i  %-i",output[3],input[3]);
      lcd_wrs(buf,255);
     
    lcd_setxy(1,50);
     
     sprintf(buf,"%-i  %-i,%-i",output[7],U_bat/10000,U_bat/1000%10);
      lcd_wrs(buf,255);    
        
        }
      */
void menu (void)
{ byte i,j,max,temp[9],f,l,c; 

if (LEFT&&RIGHT&&UP&&DOWN) pen=1;
 
lcd_clear();
if (!en) {
        main_scr();
        if (!RIGHT&&pen)
                        {
                        en=1;
                        deep=0;
                        pen=0;
                        pos[0]=0;
                        BEEP();
                        }
          }                
         
        else  
        {
        
        lcd_setxy(0,0);
        sprintf(buf,"0%-i",cur_model_num+1);
        lcd_wrs(buf,255);
        lcd_setxy(16,0);
        if (curmodel.type==1)            //  
                {
                lcd_char(125,255); 
                lcd_char(126,255); 
                }
        
           if (curmodel.type==0)            // 
                {
                lcd_char(127,255); 
                lcd_char(128,255); 
                }  
        
        lcd_setxy(33,0);
   lcd_wrsf(modeNames[curmodel.type][FLY_MODE],255);
   if (!curve_ed_enable )   
        {
        lcd_dashline(0,16,95,16);
        lcd_line(0,17,95,17,1);
        }
        
        if (deep==0) {                                                          // 
                
    pos[0]= scroll (pos[0],menuT0L);
                
       
             if (!LEFT&&pen) {en=0;pen=0;BEEP();}
             if (!RIGHT&&pen) 
                        {
                        deep=1;
                        pos[1]=0;
                        pen=0;
                        BEEP();
                        }
                
                
                
                lcd_setxy(0,8);
                lcd_wrsf("Main menu",255);
        
                menu_item( menuT0 ,menuT0L,pos[0]);
        
        
                        }
 
 
        if (deep>0) 
        {
        if (pos[0]==0)
        { if (deep==1)
                {                                                    //                
                pos[1]= scroll (pos[1],menuT1L) ;
                if (!LEFT&&pen) {deep=0; pen=0;BEEP();}
                if (!RIGHT&&pen) 
                        {
                        deep=2;
                        pos[2]=0;
                        pen=0;
                        BEEP();
                        if (pos[1]==0) pos[2]=cur_model_num;
                        }
                
                
                
                lcd_setxy(0,8);
                lcd_wrsf("Model",255);
        
                menu_item( menuT1 ,menuT1L,pos[1]);
        
                }
        if (deep==2&&pos[1]==0)                      //
                {
                lcd_setxy(0,8);
                lcd_wrsf("Select",255);  
                for (j=0; j<MAX_MODELS; j++)
                        {
                        for (i=0; i<8; i++)temp[i]=Name_table[name[j][i]];	
                        temp[8]='\0';
                        lcd_setxy(10,9*j+18);
                        if (pos[2]==j) lcd_wrs(temp,0);
                        else lcd_wrs(temp,255);
                        }
                        if (!UP&&pos[2]<MAX_MODELS-1)
                                {
                                pos[2]++;
                                BEEP();
                                }
                
                        if (!DOWN&&pos[2]>0)
                                {
                                pos[2]--;   
                                BEEP();
                                }
                        if (!LEFT&&pen){BEEP(); pen=0; deep=1; cur_model_num=pos[2]; start_model=cur_model_num; MODEL_init(); BEEP();}        
                        
                        
                }
                
        if (deep==2&&pos[1]==1)                      //
                {
                lcd_setxy(0,8);
                lcd_wrsf("Reset",255);
                lcd_setxy(10,24);
                lcd_wrsf("Are you",255);                
                lcd_setxy(15,35);
                lcd_wrsf("sure?",255);          
                if (!RIGHT&&pen)
                        {
                        BEEP();
                        lcd_clear();
                        lcd_setxy(10,24);
                        lcd_wrsf("Please",255);                
                        lcd_setxy(15,35);
                        lcd_wrsf("wait...",255); 
                        lcd_refresh();
                        MODEL_reset();
                        MODEL_init(); 
                        pen=0; 
                        deep=1;
                        BEEP();
                        } 
                 if (!LEFT&&pen) {deep=1; pen=0;BEEP();}
                }
        if (deep==2&&pos[1]==2)                      //  
                {
                lcd_setxy(0,8);
                lcd_wrsf("Copy",255);  
                
                lcd_setxy(2,18);
                lcd_wrsf("From:",255);
                
                lcd_setxy(2,36);
                lcd_wrsf("To:",255);
                
                for (i=0; i<8; i++)temp[i]=Name_table[name[T[0]][i]];	
                
                temp[8]='\0';
                
                lcd_setxy(15,27);
                
                if (pos[2]==0)
                        {  
                        if (!edit)lcd_wrs(temp,0);
                        else lcd_wrs(temp,Clip);  
                        }
                else    lcd_wrs(temp,255);
                
                for (i=0; i<8; i++)temp[i]=Name_table[name[T[1]][i]];	
                
                lcd_setxy(15,45);
                
                temp[8]='\0';
                
                if (pos[2]==1)  
                        {  
                        if (!edit)lcd_wrs(temp,0);
                        else lcd_wrs(temp,Clip);  
                        }
                else    lcd_wrs(temp,255);
                
                lcd_setxy(40,54);
                if (pos[2]==2)
                        lcd_wrsf("OK",0);
                else    lcd_wrsf("OK",255);
                
                if (!UP&&!edit&&pos[2]<2)
                                {
                                pos[2]++;
                                BEEP();
                                }
                
                if (!DOWN&&!edit&&pos[2]>0)
                                {
                                pos[2]--;   
                                BEEP();
                                }
                
                if (!LEFT&&pen&&!edit) {pen=0; deep=1; BEEP();}
                if (!LEFT&&pen&&edit) {pen=0; edit=0; BEEP();}
               
                if (!RIGHT&&pen&&!edit&&pos[2]<2) {pen=0; edit=1;BEEP();}
                                
                if (!UP&&edit&&T[pos[2]]<MAX_MODELS-1)
                                {
                                T[pos[2]]++;
                                BEEP();
                                }
                
                if (!DOWN&&edit&&T[pos[2]]>0)
                                {
                                T[pos[2]]--;   
                                BEEP();
                                }
                
                if (!RIGHT&&pen&&!edit&&pos[2]==2) {pen=0;MODEL_copy(T[0],T[1]); BEEP();deep=1;}
                
                }
        
        if (deep==2&&pos[1]==3)                      // 
                {
                lcd_setxy(0,8);
                lcd_wrsf("Name",255);  
                
                for (i=0; i<8; i++) 
                        {
                        lcd_setxy(i*11+5,25);
                        if (edit&&pos[2]==i)lcd_char(Name_table[curmodel.name[i]],Clip);
                        else lcd_char(Name_table[curmodel.name[i]],255);
                        }
                
                lcd_rectangle(pos[2]*11+3,23,pos[2]*11+14,34,1);
                
                if (!LEFT&&pen&&!edit) {pen=0; deep=1; BEEP();}
                
                if (!RIGHT&&pen&&!edit) {pen=0; edit=1;BEEP();name_init();}
                
                if (!LEFT&&pen&&edit) {pen=0; edit=0; BEEP(); name[cur_model_num][pos[2]]=curmodel.name[pos[2]];}
                
                
                if (!DOWN&&!edit&&pos[2]<7)
                                {
                                pos[2]++;
                                BEEP();
                                }
                
                if (!UP&&!edit&&pos[2]>0)
                                {
                                pos[2]--;   
                                BEEP();
                                }
                
                if (!DOWN&&edit&&curmodel.name[pos[2]]<64)
                                {
                                curmodel.name[pos[2]]++;
                                BEEP1();
                                }
                
                if (!UP&&edit&&curmodel.name[pos[2]]>0)
                                {
                                curmodel.name[pos[2]]--;   
                                BEEP1();
                                }
                
                
                
                }
        
                 if (deep==2&&pos[1]==4)                      //  
                {
                
                lcd_setxy(0,8);
                lcd_wrsf("Type",255);
                
                lcd_setxy(5,25);
                lcd_wrsf(menuT6[curmodel.type],255);
                               
                if (!UP&&curmodel.type<1)
                                {
                                curmodel.type++;
                                 BEEP1();
                                }
                
                if (!DOWN&&curmodel.type>0)
                                {
                                curmodel.type--;   
                                 BEEP1();
                                }
                
                
                if (!LEFT&&pen) {pen=0; deep=1; BEEP(); type[cur_model_num]=curmodel.type; BEEP();}
                
                }
                
                if (deep==2&&pos[1]==5)                      //  
                {
                lcd_setxy(0,8);
                lcd_wrsf("Copy MODE",255);  
                
                lcd_setxy(2,18);
                lcd_wrsf("From:",255);
                
                lcd_setxy(2,36);
                lcd_wrsf("To:",255);
                
                for (i=0; i<8; i++)temp[i]=modeNames[curmodel.type][T[0]][i];	
                
                temp[8]='\0';
                
                lcd_setxy(15,27);
                
                if (pos[2]==0)  
                        {
                        if (!edit)lcd_wrs(temp,0);
                        else lcd_wrs(temp,Clip);
                        }
                else    lcd_wrs(temp,255);
                
                for (i=0; i<8; i++)temp[i]=modeNames[curmodel.type][T[1]][i];	
                
                lcd_setxy(15,45);
                
                temp[8]='\0';
                
                if (pos[2]==1)  
                        {
                        if (!edit)lcd_wrs(temp,0);
                        else lcd_wrs(temp,Clip);
                        }
                else    lcd_wrs(temp,255);
                
                lcd_setxy(40,54);
                if (pos[2]==2)
                        lcd_wrsf("OK",0);
                else    lcd_wrsf("OK",255);
                
                if (!UP&&!edit&&pos[2]<2)
                                {
                                pos[2]++;
                                BEEP();
                                }
                
                if (!DOWN&&!edit&&pos[2]>0)
                                {
                                pos[2]--;   
                                BEEP();
                                }
                
                if (!LEFT&&pen&&!edit) {pen=0; deep=1; BEEP();}
                if (!LEFT&&pen&&edit) {pen=0; edit=0; BEEP();}
               
                if (!RIGHT&&pen&&!edit&&pos[2]<2) {pen=0; edit=1;BEEP();}
                                
                if (!UP&&edit&&T[pos[2]]<2)
                                {
                                T[pos[2]]++;
                                BEEP();
                                }
                
                if (!DOWN&&edit&&T[pos[2]]>0)
                                {
                                T[pos[2]]--;   
                                BEEP();
                                }
                
                if (!RIGHT&&pen&&!edit&&pos[2]==2) {pen=0;MODE_copy(T[0],T[1]);MODEL_init(); BEEP();deep=1;}
                
                }
                
                
              if (deep==2&&pos[1]==6)                      // 
                {  
                 lcd_setxy(0,8);
                lcd_wrsf("Modulation",255);  
        
                if (!UP&&curmodel.modulation<1)
                                {
                                curmodel.modulation++;
                                BEEP();
                                
                                if (curmodel.modulation==0) TCCR1A=0x82;
                                if (curmodel.modulation==1) TCCR1A=0xC2;
                                }
                
                if (!DOWN&&curmodel.modulation>0)
                                {
                                curmodel.modulation--;   
                                BEEP();
                                if (curmodel.modulation==0) TCCR1A=0x82;
                                if (curmodel.modulation==1) TCCR1A=0xC2;
                                }
                 
                 
                 if (!LEFT&&pen) {deep=1; modulation[cur_model_num]=curmodel.modulation; BEEP();}
                 
                 
                lcd_setxy(15,25);
                lcd_wrsf(modulNames[curmodel.modulation],255); 
                 
                 
                 
                 
                 }
       
       
         if (deep==2&&pos[1]==7)                      //      ===========================================================
                { 
                lcd_setxy(0,8);
                lcd_wrsf("MAX CH",255); 
                
                if (!DOWN&&curmodel.num_ch<8)
                                {
                                curmodel.num_ch++;
                                BEEP();
                                
                                
                                }
                
                if (!UP&&curmodel.num_ch>2)
                                {
                                curmodel.num_ch--;   
                                BEEP();
                                
                                }
                 
                 
                 if (!LEFT&&pen) {deep=1; num_ch[cur_model_num]=curmodel.num_ch; BEEP(); pen=0;}
                 
                 
                lcd_setxy(15,25);
                lcd_deg12x16(curmodel.num_ch,255);
                
                
                
                
                }
       
       
       
       
       
       
        }
        
        if (pos[0]==1)
        {       if (deep==1){                                                         //      CONTROLS          
                        if (!UP&&pos[1]<menuT2L-1)
                                {pos[1]++;
                                BEEP();
                                } 
                                
                        if (!DOWN&&pos[1]>0)
                                {pos[1]--;
                                 BEEP();
                                 }
                        if (!LEFT&&pen) {deep=0; pen=0;BEEP();}
                        if (!RIGHT&&pen) 
                                {
                                deep=2;
                                pos[2]=0;
                                edit=0;
                                pen=0;
                                
                                BEEP();
                                }
                  
                
                
                        lcd_setxy(0,8);
                        lcd_wrsf("Controls",255);
        
                        menu_item( menuT2 ,menuT2L,pos[1]);
                
               } 
                if (deep==2)                                       // CONtrols
                        {
                        if (pos[1]<2||pos[1]==3) max=6;
                        if (pos[1]>4&&pos[1]<8) max=4;
                        if (pos[1]>7||pos[1]==2) max=5;
                        
                        if (!UP&&(pos[2]<max-1)&&!edit)
                                {
                                pos[2]++;
                                if  (pos[1]>3&&pos[1]<7&&pos[2]==1) pos[2]++;               
                                BEEP();
                                }
                
                        if (!DOWN&&(pos[2]>0)&&!edit)
                                {pos[2]--;   
                                if  (pos[1]>3&&pos[1]<7&&pos[2]==1) pos[2]--; 
                                BEEP();
                                }
                        
                        if (!LEFT&&pen&&!edit) {deep=1; pen=0;BEEP();}
                        if (!LEFT&&pen&&edit&&!curve_ed_enable) {edit=0; pen=0;SAVE_CH(cur_model_num,pos[1],pos[2]);     } 
                        
                        if (!RIGHT&&pen&&!edit&&pos[2]!=1) {edit=1; pen=0;BEEP(); }
                        
                      
                        
                        if (pos[2]==0&&!UP&&edit) contr[pos[1]].reverse[FLY_MODE]=-1;
                         if (pos[2]==0&&!DOWN&&edit) contr[pos[1]].reverse[FLY_MODE]=1;
                        
                           if (pos[2]==2&&!DOWN&&edit&&contr[pos[1]].minRates[FLY_MODE]<150)    {contr[pos[1]].minRates[FLY_MODE]+=2;  BEEP1();}
                         if (pos[2]==2&&!UP&&edit&&contr[pos[1]].minRates[FLY_MODE]>0)          {contr[pos[1]].minRates[FLY_MODE]-=2;  BEEP1();}
                                                                                                                                       
                          if (pos[2]==3&&!DOWN&&edit&&contr[pos[1]].maxRates[FLY_MODE]<150)     {contr[pos[1]].maxRates[FLY_MODE]+=2;  BEEP1();}
                         if (pos[2]==3&&!UP&&edit&&contr[pos[1]].maxRates[FLY_MODE]>0)          {contr[pos[1]].maxRates[FLY_MODE]-=2;  BEEP1();}
                        
                        
                        if (pos[1]<4&&pos[1]!=2)
                                {
                                if (pos[2]==4&&!DOWN&&edit&&contr[pos[1]].minDRates[FLY_MODE]<150)     { contr[pos[1]].minDRates[FLY_MODE]+=2; BEEP1();}
                                if (pos[2]==4&&!UP&&edit&&contr[pos[1]].minDRates[FLY_MODE]>0)         { contr[pos[1]].minDRates[FLY_MODE]-=2; BEEP1();}
                               
                                if (pos[2]==5&&!DOWN&&edit&&contr[pos[1]].maxDRates[FLY_MODE]<150)     { contr[pos[1]].maxDRates[FLY_MODE]+=2; BEEP1();}
                                if (pos[2]==5&&!UP&&edit&&contr[pos[1]].maxDRates[FLY_MODE]>0)         { contr[pos[1]].maxDRates[FLY_MODE]-=2; BEEP1();}
                                
                                }
                        if (pos[1]==2)// Throttle cut
                                { 
                                if (pos[2]==4&&!DOWN&&edit&&contr[pos[1]].minDRates[FLY_MODE]<150)     { contr[pos[1]].minDRates[FLY_MODE]+=2; BEEP1();}
                                if (pos[2]==4&&!UP&&edit&&contr[pos[1]].minDRates[FLY_MODE]>0)          {contr[pos[1]].minDRates[FLY_MODE]-=2;  BEEP1();}
                                }
                        if (pos[2]==1&&!RIGHT&&pen&&!edit) {curve_ed_enable=1; edit=1;pen=0;pos[3]=0;edit_cur=0;BEEP();}
                        if (pos[2]==1&&!LEFT&&pen&&edit&&curve_ed_enable&&!edit_cur) {curve_ed_enable=0; edit=0;pen=0;BEEP();}
                        
                        if(curve_ed_enable)                                             //
                                {
                                 
                                if (!DOWN&&!edit_cur&&pen&&pos[3]<6) {pos[3]++;pen=0;BEEP();}
                                if (!UP&&!edit_cur&&pen&&pos[3]>0) {pos[3]--;pen=0;BEEP();}
                                
                                if (!RIGHT&&pen) {edit_cur=1; pen=0;BEEP();} 
                                
                                if (!DOWN&&edit_cur&&contr[pos[1]].nodes[pos[3]][FLY_MODE]<100) {contr[pos[1]].nodes[pos[3]][FLY_MODE]+=2; BEEP1();}
                                if (!UP&&edit_cur&&contr[pos[1]].nodes[pos[3]][FLY_MODE]>-100){ contr[pos[1]].nodes[pos[3]][FLY_MODE]-=2;  BEEP1();}
                               
                                if (!LEFT&&pen) {edit_cur=0; pen=0;SAVE_NODE();} 
                                
                                edit_curve(pos[3]);
                                
                                }
                       
                        
                        lcd_setxy(0,7);
                        lcd_wrsf(menuT2[pos[1]],255);        
                        lcd_setxy(70,7);
                        lcd_wrsf("   ",255);          
                        
                        if (!curve_ed_enable) edit_CH (pos[1],pos[2])    ;
                        
                        
                                if (pos[1]>7)                         ////     
                                        {
                                        if (pos[2]==4&&!UP&&edit&&contr[pos[1]].from[FLY_MODE]>0){ contr[pos[1]].from[FLY_MODE]--;   BEEP1();}
                                        if (pos[2]==4&&!DOWN&&edit&&contr[pos[1]].from[FLY_MODE]<7) {contr[pos[1]].from[FLY_MODE]++;   BEEP1();}      
                                        
                                        
                                        }
                        
                        
                        
                        
                        
                        
                        
                        
                        
                        
                        
                        
                        
                        }
              
              }
              
              
              
              if (pos[0]==2)
                {
                if (deep==1)
                        {                                                          //CHANNELS          
                        if (!UP&&pos[1]<menuT5L-1)
                                {
                                pos[1]++;
                                BEEP();
                                }
                        if (!DOWN&&pos[1]>0)
                                {
                                pos[1]--;
                                BEEP();
                                }
                        if (!LEFT&&pen) {deep=0; pen=0; BEEP();}
                        if (!RIGHT&&pen) 
                                {
                                deep=2;
                                pos[2]=0;
                                pen=0;
                                BEEP();
                                }
                        
                
                
                        lcd_setxy(0,8);
                        lcd_wrsf("Channels",255);
        
                        menu_item( menuT5 ,menuT5L,pos[1]);
                        }
                if (deep==2)
                        {
                        lcd_setxy(0,8);
                        lcd_wrsf(menuT5[pos[1]],255);
                        lcd_setxy(70,8);
                        lcd_wrsf("   ",255);  
                        if (!LEFT&&!edit&&pen) {deep=1; pen=0; BEEP();}
                        if (!LEFT&&edit&&pen) {edit=0; pen=0;CH[cur_model_num][pos[1]][pos[2]][FLY_MODE]=chans[pos[1]].CH[pos[2]][FLY_MODE]; BEEP();}
                        if (!RIGHT&&pen) {edit=1; pen=0; BEEP();}
                        
                        if (!UP&&!edit&&pos[2]<10)
                                {
                                pos[2]++;
                                BEEP();
                                }
                        if (!DOWN&&!edit&&pos[2]>0)
                                {
                                pos[2]--;
                                BEEP();
                                }
                        if (!DOWN&&edit&&chans[pos[1]].CH[pos[2]][FLY_MODE]<100)
                                {
                                chans[pos[1]].CH[pos[2]][FLY_MODE]+=2;
                                 BEEP1();
                                }
                        if (!UP&&edit&&chans[pos[1]].CH[pos[2]][FLY_MODE]>-100)
                                {
                                chans[pos[1]].CH[pos[2]][FLY_MODE]-=2;
                                 BEEP1();
                                }
                        
                        lcd_line(92,18,92,64,1);
                        lcd_line(95,18,95,64,1);
        
                        if (pos[2]>=5&&pos[2]<10)
                                {
                                lcd_line(93,33,93,48,1);
                                lcd_line(94,33,94,48,1);
                                lcd_line(93,18,94,18,1);
                                f=5; 
                                l=10;
                                }      
                        if (pos[2]>=10)
                                {
                                lcd_line(93,48,93,64,1);
                                lcd_line(94,48,94,64,1);
                                lcd_line(93,18,94,18,1);
                                f=10; 
                                l=11;
                                }      
                        
                         if (pos[2]<5)        
                                {
                                lcd_line(93,18,93,33,1);
                                lcd_line(94,18,94,33,1);
                                lcd_line(93,64,94,64,1);
                                f=0; 
                                l=5;
                                }  
                        
                        c=0;
                        for (i=f; i<l; i++)
                                {
                                
                                if (i==pos[2])
                                        {
                                        lcd_setxy(0,c*9+18);
                                        if (!edit)lcd_wrsf(menuT2[i],0);
                                        else lcd_wrsf(menuT2[i],Clip);
                                        
                                        lcd_setxy(56,c*9+18);
                                         if (!edit)lcd_wrsf("    ",0);
                                        else lcd_wrsf("    ",Clip);
                                        
                                        lcd_setxy(60,c*9+18);
                                        sprintf(buf,"%-i",chans[pos[1]].CH[i][FLY_MODE]);
                                        if (!edit)lcd_wrs(buf,0);
                                        else lcd_wrs(buf,Clip);
                                        
                                        }
                                else
                                        {
                                        lcd_setxy(0,c*9+18);
                                        lcd_wrsf(menuT2[i],255);
                                        lcd_setxy(56,c*9+18);
                                        lcd_wrsf("   ",255);
                                        lcd_setxy(60,c*9+18);
                                        sprintf(buf,"%-i",chans[pos[1]].CH[i][FLY_MODE]);
                                        lcd_wrs(buf,255);
                                        }
                                c++;
                                
                                }
                          
                        
                        
                        }
                
                
                }
      
      
         if (pos[0]==3)
        {
        if (deep==1)
                {                                                          //    TIMER            
                if (!UP&&pos[1]<menuT3L-1)
                        { 
                        pos[1]++;
                        BEEP();
                        }
                if (!DOWN&&pos[1]>0)
                        {
                        pos[1]--;
                        BEEP();
                        }
                if (!LEFT&&pen) {deep=0; pen=0;BEEP();}
                if (!RIGHT&&pen) 
                        {
                        deep=2;
                        pos[2]=0;
                        pen=0;
                        BEEP();
                        }
                  
                
                
                lcd_setxy(0,8);
                lcd_wrsf("Timer",255);
        
                menu_item( menuT3 ,menuT3L,pos[1]);
        
        
                }
       
       if (deep==2&&pos[1]==0)    // 
                {  
                if (!LEFT&&pen) {deep=1; pen=0; timer[cur_model_num]=curmodel.timer;BEEP();}
               
                if (!DOWN&&curmodel.timer<3599)
                        { 
                        curmodel.timer+=10;
                        BEEP1();
                        }
                if (!UP&&curmodel.timer>0)
                        {
                       curmodel.timer-=10;
                        BEEP1();
                        }
                
              
                
                
               
                        sprintf(buf,"%-i:%-i",curmodel.timer/60,curmodel.timer%60);
                 
                lcd_setxy(25,25);
                lcd_wrs(buf,255);
                }
       
       if (deep==2&&pos[1]==1)      // 
                {
                if (!LEFT&&pen) {deep=1;timer_mode[cur_model_num]=curmodel.timer_mode; pen=0;BEEP();}  
                
                
                
                if (!UP&&curmodel.timer_mode<3)
                        { 
                        curmodel.timer_mode++;
                        BEEP();
                        }
                if (!DOWN&&curmodel.timer_mode>0)
                        {
                       curmodel.timer_mode--;
                        BEEP();
                        }
                
                lcd_setxy(15,20);
                lcd_wrsf(Timer_modes1[curmodel.timer_mode/2],255);
                lcd_setxy(15,30);
                lcd_wrsf(Timer_modes2[curmodel.timer_mode%2],255);
                
                }
       
       
       
       }
       
       if (pos[0]==4)
                { 
                if (deep==1)
                        {                                                         //OPTIONS         
                        if (!UP&&pos[1]<menuT4L-1)
                                {
                                pos[1]++;
                                BEEP();
                                }
                        if (!DOWN&&pos[1]>0)
                                {
                                pos[1]--;
                                BEEP(); 
                                }
                        if (!LEFT&&pen) {deep=0; pen=0;BEEP();}
                        if (!RIGHT&&pen) 
                                {
                                deep=2;
                                pos[2]=0;
                                pen=0;
                                BEEP();
                                }
                  
                
                
                lcd_setxy(0,8);
                lcd_wrsf("Options",255);
        
                menu_item( menuT4 ,menuT4L,pos[1]);
                        }
                if (deep==2&&pos[1]==0)
                        {
                        lcd_setxy(0,8);
                        lcd_wrsf("Sound",255);
                        lcd_setxy(10,25);
                        if (sound)lcd_wrsf("ON",255); 
                        else lcd_wrsf("OFF",255);
                        if (!DOWN&&pen) {sound=1; BEEP();pen=0;}
                        if (!UP&&pen) {sound=0; BEEP();pen=0;}
                        if (!LEFT&&pen) {deep=1; pen=0; EEPRsound=sound; BEEP();}
                        }
                        
                
                
                
                
                
                
                }
       
       
       
       
       
        }
  }      
 lcd_refresh();
 }










void calibr (void)
{
unsigned char i,x2,y2;
int t1,t2;   
    read_adc(Ailerons);
        AD[0]=ADCW-ADmid[0];
        read_adc(Throttle);
        AD[2]=ADCW-ADmid[2];
        read_adc(Rudder);
        AD[3]=ADCW-ADmid[3];
        read_adc(Elevator);
        AD[1]=ADCW-ADmid[1];
        read_adc(Rpop_contr);
        AD[4]=ADCW-ADmid[4];
        read_adc(Batt);
        U_bat=ADCW;
        U_bat=U_bat*2;
   
   
    
 for (i=0; i<5; i++)
        {
        ADmin[i]=AD[i];
        ADmax[i]=AD[i];
        }
  
 sound=1;
 
 lcd_clear();
 lcd_setxy(4,5);
 lcd_wrsf("Calibrating",255);
 lcd_refresh();
 delay_ms(1000);
  
  BEEP();
   BEEP();
    BEEP();
      BEEP();
        BEEP();
while (RIGHT){
lcd_clear();

        read_adc(Ailerons);
        AD[0]=ADCW-ADmid[0];
        read_adc(Throttle);
        AD[2]=ADCW-ADmid[2];
        read_adc(Rudder);
        AD[3]=ADCW-ADmid[3];
        read_adc(Elevator);
        AD[1]=ADCW-ADmid[1];
        read_adc(Rpop_contr);
        AD[4]=ADCW-ADmid[4];
        read_adc(Batt);
        U_bat=ADCW;
        U_bat=U_bat*2;
    
lcd_line(8,10,8,40,1);
lcd_line(8,10,38,10,1);
lcd_line(38,10,38,40,1);
lcd_line(8,40,38,40,1);
lcd_line(7,9,7,41,1);
lcd_line(7,9,39,9,1);
lcd_line(39,9,39,41,1);
lcd_line(7,41,39,41,1);


lcd_line(58,10,58,40,1);
lcd_line(58,10,88,10,1);
lcd_line(88,10,88,40,1);
lcd_line(58,40,88,40,1);
lcd_line(57,9,57,41,1);
lcd_line(57,9,89,9,1);
lcd_line(89,9,89,41,1);
lcd_line(57,41,89,41,1);

for (i=0; i<5; i++){
      if (ADmin[i]>AD[i]) ADmin[i]=AD[i];
    if (ADmax[i]<AD[i]) ADmax[i]=AD[i];}


x2=(AD[0]-ADmin[0])*28/(ADmax[0]-ADmin[0])+59;
y2=30-(AD[2]-ADmin[2])*28/(ADmax[2]-ADmin[2])+9;  

lcd_pixel(x2,y2-2,1);        
lcd_line(x2-1,y2-1,x2+1,y2-1,1); 
lcd_line(x2-2,y2,x2+2,y2,1); 
lcd_line(x2-1,y2+1,x2+1,y2+1,1); 
lcd_pixel(x2,y2+2,1); 

x2=(AD[3]-ADmin[3])*28/(ADmax[3]-ADmin[3])+9            ;
y2=30-(AD[1]-ADmin[1])*28/(ADmax[1]-ADmin[1])+9; 

lcd_pixel(x2,y2-2,1);        
lcd_line(x2-1,y2-1,x2+1,y2-1,1); 
lcd_line(x2-2,y2,x2+2,y2,1); 
lcd_line(x2-1,y2+1,x2+1,y2+1,1); 
lcd_pixel(x2,y2+2,1); 


x2=(AD[4]-ADmin[4])*50/(ADmax[4]-ADmin[4])+23 ;
lcd_rectangle(23,50,73,52,1);
lcd_fillrect(x2-1,48,x2+1,54,1);

lcd_refresh();       
}
    read_adc(Ailerons);
        AD[0]=ADCW-ADmid[0];
        read_adc(Throttle);
        AD[2]=ADCW-ADmid[2];
        read_adc(Rudder);
        AD[3]=ADCW-ADmid[3];
        read_adc(Elevator);
        AD[1]=ADCW-ADmid[1];
        read_adc(Rpop_contr);
        AD[4]=ADCW-ADmid[4];
        read_adc(Batt);
        U_bat=ADCW;
        U_bat=U_bat*2;
        
for (i=0; i<5; i++)
        {
        EEPR_ADmid[i]=AD[i];
        t1=7500/(ADmax[i]-AD[i]);
        t2=7500/(AD[i]-ADmin[i]);
        EEPR_Kmin[i]=t2;
        EEPR_Kmax[i]=t1;
       
         BEEP();
          BEEP();
        }
}       







void TX_init (void)
{ char i;
cur_model_num=start_model;

for (i=0; i<5; i++)
        {
        
        
        ADmid[i]=EEPR_ADmid[i];
        Kmin[i]=EEPR_Kmin[i];
        Kmax[i]=EEPR_Kmax[i];
                
        }

sound=EEPRsound;
MODEL_init();

if (curmodel.modulation==0) TCCR1A=0x82;
if (curmodel.modulation==1) TCCR1A=0xC2;

if  (curmodel.timer_mode<2)    time=0;
                else    time=curmodel.timer;



}

void TX_reset (void)
{#asm("cli")
lcd_setxy(15,8);
lcd_wrsf("Please",255);
lcd_setxy(25,16);
lcd_wrsf("wait...",255);

lcd_rectangle(18,35,78,45,1);
lcd_refresh();
cur_model_num=0;
MODEL_reset();
lcd_fillrect(18,35,33,45,1);
lcd_refresh();

cur_model_num=1;
MODEL_reset();
lcd_fillrect(18,35,48,45,1);
lcd_refresh();

cur_model_num=2;
MODEL_reset();
lcd_fillrect(18,35,63,45,1);
lcd_refresh();

cur_model_num=3;
MODEL_reset();
lcd_fillrect(18,35,78,45,1);
lcd_refresh();

start_model=0;
EEPRsound=1;
calibr();

FirstON=1;
#asm("sei")
}


